import { system, world } from "@minecraft/server";

const recipes = [
    {
        output: "coconut_curry",
        ingredients: [
            { item: "ww_dx:coconut", count: 1 },
            { item: "ww_dx:curry", count: 1 },
            { item: "ww_dx:chili_powder", count: 1 },
            { item: "minecraft:chicken", count: 1 },
        ],
    },
    {
        output: "curry",
        ingredients: [
            { item: "minecraft:chicken", count: 1 },
            { item: "ww_dx:coconut_water", count: 1 },
            { item: "ww_dx:curry_powder", count: 1 },
            { item: "ww_dx:rice", count: 1 },
        ],
    },
    {
        output: "gluten_free_mac_and_cheese",
        ingredients: [
            { item: "ww_dx:rice_noodles", count: 1 },
            { item: "ww_dx:cheese", count: 1 },
        ],
    },
    {
        output: "mac_and_cheese",
        ingredients: [
            { item: "ww_dx:noodles", count: 1 },
            { item: "ww_dx:cheese", count: 1 },
        ],
    },
    {
        output: "ratatouille",
        ingredients: [
            { item: "ww_dx:zucchini", count: 1 },
            { item: "ww_dx:eggplant", count: 1 },
            { item: "ww_dx:tomato", count: 1 },
            { item: "ww_dx:olive_oil", count: 1 },
        ],
    },
    {
        output: "rice_noodle_stir_fry",
        ingredients: [
            { item: "ww_dx:rice_noodles", count: 1 },
            { item: "ww_dx:soy_sauce", count: 1 },
            { item: "ww_dx:broccoli", count: 1 },
            { item: "minecraft:carrot", count: 1 },
        ],
    },
    {
        output: "spaghetti",
        ingredients: [
            { item: "ww_dx:noodles", count: 1 },
            { item: "ww_dx:tomato_sauce", count: 1 },
            { item: "ww_dx:basil", count: 1 },
        ],
    },
];



const pot = new Map();


function processPotInventory(entity) {
    const id = entity.id;


    if (pot.get(id)?.isProcessing) {

        return;
    }

    const inventoryComponent = entity.getComponent("minecraft:inventory");

    if (!inventoryComponent || !inventoryComponent.container) {

        return;
    }

    const inventory = inventoryComponent.container;

    for (const recipe of recipes) {
     
        let matches = true;

        const ingredientsMap = new Map(
            recipe.ingredients.map((ingredient) => [ingredient.item, ingredient.count])
        );

        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i);
            if (item) {
                if (ingredientsMap.has(item.typeId)) {
                    const remainingCount = ingredientsMap.get(item.typeId) - item.amount;
                    if (remainingCount <= 0) {
                        ingredientsMap.delete(item.typeId);
                    } else {
                        ingredientsMap.set(item.typeId, remainingCount);
                    }
                } else {
             
                    matches = false;
                    break;
                }
            }
        }

        if (matches && ingredientsMap.size === 0) {
            entity.runCommandAsync("summon ww_dx:processing_particle ~ ~1 ~")
            for (const ingredient of recipe.ingredients) {
                let remainingToRemove = ingredient.count;

                for (let i = 0; i < inventory.size; i++) {
                    const item = inventory.getItem(i);
                    if (item && item.typeId === ingredient.item) {
                        if (item.amount > remainingToRemove) {
                            item.amount -= remainingToRemove;
                            inventory.setItem(i, item);
                            break;
                        } else {
                            remainingToRemove -= item.amount;
                            inventory.setItem(i, undefined);
                        }
                    }
                }
            }

            pot.set(id, { isProcessing: true });
            system.runTimeout(() => {
                if (!entity.isValid()) return;
                const { x, y, z } = entity.location;
                entity.runCommandAsync(`loot spawn ${x} ${y + 1} ${z} loot ${recipe.output}`);
                entity.runCommandAsync("event entity @e[type=ww_dx:processing_particle,r=1] ww_dx:despawn")
                entity.runCommandAsync("playsound ww_dx:finish_cooking @a[r=5]")

                pot.set(id, { isProcessing: false });
            }, 200);

            return; 
        } else {
           
        }
    }

 
}
let worldInitialize = false;
world.afterEvents.playerSpawn.subscribe((event) => {
    worldInitialize = true;

})
function checkPot() {
    if(!worldInitialize)return;
    const currentDimension = world.getDimension(world.getPlayers()[0].dimension.id);

    for (const entity of currentDimension.getEntities()) {
        if (entity.typeId === "ww_dx:pot") {
            if (!pot.has(entity.id)) {
                pot.set(entity.id, { isProcessing: false });
            }

            processPotInventory(entity);
        }
    }
}

system.runInterval(() => {
    checkPot();
}, 20);
